const {
	generate_questions,
	inputQuestion,
	toggleQuestion,
	selectQuestion,
	dateQuestion
} = require('../utils/questions_generator');
const path = require('path');
const cli = require('../utils/cli');

const {
	generateReport,
	reportOutputType
} = require('../utils/report_generator');
const { prompt } = require('enquirer');
const event = require('../utils/event');
const { debug } = cli.flags;

const meeting_mom = async file => {
	let path_to_questions = path.join(__dirname, '../questions/' + file);
	let questions = await generate_questions(path_to_questions);
	let answers = [];
	for (const question of questions) {
		switch (question.type) {
			case 'date':
				await dateQuestion(question, answers);
				console.log();
				break;
			case 'input':
				await inputQuestion(question, answers);
				console.log();
				break;
			case 'toggle':
				await toggleQuestion(question, answers);
				console.log();
				break;
			case 'select':
				await selectQuestion(question, answers);
				console.log();
				break;
		}
	}
	debug && console.log(answers);
	return await generateReport(answers, path_to_questions);
};

module.exports = { meeting_mom };
