const os = require('os');
const store = require('data-store');
const path = require('path');
const helper = require('./helpers');

const mainStore = new store({
	path: path.join(os.homedir(), `.history/elm-helper-cli/main.json`)
});
const getProjects = async () => await mainStore.get('projects');

const projectTeam = async projectId => {
	return await mainStore.get(`projects.${projectId}.team`);
};

const getMainUser = async () => await mainStore.get('main_user');

const addUser = data => {
	data.username = helper.extractUsername(data.email);
	mainStore.set(`main_user`, data);
	console.log(path.join(os.homedir(), `.history/elm-helper-cli/main.json`));

	return data;
};

module.exports = {
	addUser,
	getMainUser,
	mainStore,
	getProjects,
	projectTeam
};
