const Helper = require('./helpers');
const titleMarkup = (key, value) => {
	return `h2. ${value} \n ---- \n`;
};

const keyValueMarkup = (key, value, newLine = false) => {
	return `*${key}*${newLine ? ':\n' : ': '}${value} \n`;
};

const keyListMarkup = (
	key,
	values,
	valueOnly = false,
	isUsernames = false,
	numbered = false
) => {
	let markup = '';
	markup += `h3. ${key}: \n`;
	values.forEach(value => {
		markup +=
			printOutLists(numbered ? '#' : '-', value, isUsernames, valueOnly) +
			'\n';
	});
	return markup;
};

function printOutLists(startWith, value, isUsernames, valueOnly) {
	if (Helper.isObject(value)) {
		let valueMarkup = isUsernames ? `[~${value.value}]` : value.value;
		if (valueOnly) {
			return `${startWith} ${valueMarkup}`;
		} else {
			return `${startWith} *${value.key}*: ${valueMarkup}`;
		}
	} else {
		return `${startWith} ${value}`;
	}
}

module.exports = {
	titleMarkup,
	keyValueMarkup,
	keyListMarkup
};
