const cheerio = require('cheerio');
const helper = require('../helpers');

const getPageInitStructure = () => {
	return `<p> <br/> </p> <h2> <strong>Evidence:</strong> </h2> <p> <br/> </p> <table class="wrapped"> <colgroup> <col/> <col/> <col/> </colgroup> <tbody> <tr> <th colspan="3"> <h3>builds</h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr> <tr> <td> <br/> </td> <td> <br/> </td> <td> <br/> </td> </tr> </tbody> </table> <p> <br/> </p> <p> <br/> </p> <table class="wrapped"> <colgroup> <col/> <col/> <col/> </colgroup> <tbody> <tr> <th colspan="3"> <h3>Wiki Updates</h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr> <tr> <td> <br/> </td> <td> <br/> </td> <td> <br/> </td> </tr> </tbody> </table> <p> <br/> </p> <p> <br/> </p> <table class="wrapped"> <colgroup> <col/> <col/> <col/> </colgroup> <tbody> <tr> <th colspan="3"> <h3>Initiative</h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr> <tr> <td> <br/> </td> <td> <br/> </td> <td> <br/> </td> </tr> </tbody> </table> <p> <br/> </p> <p> <br/> </p> <table class="wrapped"> <colgroup> <col/> <col/> <col/> </colgroup> <tbody> <tr> <th colspan="3"> <h3>Reusable Components</h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr> <tr> <td> <br/> </td> <td> <br/> </td> <td> <br/> </td> </tr> </tbody> </table> <p> <br/> </p> <p> <br/> </p> <table class="wrapped"> <colgroup> <col/> <col/> <col/> </colgroup> <tbody> <tr> <th colspan="3"> <h3>Technical Enhancements</h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr> <tr> <td> <br/> </td> <td> <br/> </td> <td> <br/> </td> </tr> </tbody> </table> <p> <br/> </p> <p> <br/> </p> <table class="wrapped"> <colgroup> <col/> <col/> <col/> </colgroup> <tbody> <tr> <th colspan="3"> <h3>other</h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr> <tr> <td> <br/> </td> <td> <br/> </td> <td> <br/> </td> </tr> </tbody> </table>`;
};

const convertHtmlToObject = pageContent => {
	const content = cheerio.load(pageContent);

	let data = {};
	content('.wrapped')
		.map((i, element) => {
			let title = content(element)
				.find('h3')
				.text()
				.replace(/ /g, '_')
				.toLowerCase();
			const obj = {
				[title]: content(element)
					.find('tr')
					.map((i, element) => {
						if (i > 1) {
							return {
								date: content(element).find('td').eq(0).html(),
								URL: content(element).find('td').eq(1).text(),
								note: content(element).find('td').eq(2).text()
							};
						}
					})
					.get()
			};
			data = { ...data, ...obj };
		})
		.get();

	return data;
};

const convertObjectToHtml = object => {
	let htmlContent = '';
	// set title
	htmlContent +=
		'<p><br/></p><h2><strong>Evidence:</strong></h2><p><br/></p>';

	Object.keys(object).forEach(key => {
		let title = key.replace(/_/g, ' ');
		htmlContent +=
			'<table class="wrapped"><colgroup><col/><col/><col/></colgroup><tbody>';

		htmlContent += `<tr> <th colspan="3"> <h3>  ${helper.capitalizeFirstLetter(
			title
		)} </h3> </th> </tr> <tr> <th>Date</th> <th>URL</th> <th>Note</th> </tr>`;

		if (object[key].length > 0) {
			object[key].forEach(item => {
				let containURL = helper.isContainURL(item.URL)
					? '<a href="' + item.URL + '">' + item.URL + '</a>'
					: item.URL;
				if (item.date !== undefined) {
					htmlContent += `<tr> <td> ${item.date} </td> <td> ${containURL} </td> <td>${item.note}</td> </tr>`;
				}
			});
		}

		htmlContent += '</tbody></table><br/><br/>';
	});

	return htmlContent;
};

module.exports = {
	convertHtmlToObject,
	getPageInitStructure,
	convertObjectToHtml
};
